"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.checkingCloses = void 0;
function checkingCloses(browser, callStatus) {
    return __awaiter(this, void 0, void 0, function* () {
        let processClose = false;
        if (browser['_process']) {
            browser['_process'].once('close', () => {
                processClose = true;
            });
        }
        new Promise((resolve, reject) => __awaiter(this, void 0, void 0, function* () {
            if (typeof browser !== 'string') {
                let err;
                do {
                    try {
                        yield new Promise((r) => setTimeout(r, 2000));
                        if (processClose) {
                            browser.close().catch((e) => reject(e));
                            callStatus && callStatus(true);
                            err = false;
                        }
                        else {
                            throw 1;
                        }
                    }
                    catch (e) {
                        err = true;
                    }
                } while (err);
            }
        }));
    });
}
exports.checkingCloses = checkingCloses;
//# sourceMappingURL=checking-closes.js.map