"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.appExpress = void 0;
const express_1 = __importDefault(require("express"));
const cors_1 = __importDefault(require("cors"));
const router = express_1.default.Router();
function appExpress(options) {
    const app = (0, express_1.default)();
    app.use((0, cors_1.default)({
        origin: function (origin, callback) {
            if (!origin) {
                return callback(null, true);
            }
            return callback(null, true);
        },
    }));
    const corsOptions = {
        origin: '*',
    };
    app.set('view engine', 'ejs');
    app.set('views', `${__dirname}/views`);
    app.use(express_1.default.json());
    app.use(express_1.default.urlencoded({ extended: true }));
    app.use(express_1.default.json({ strict: false }));
    app.on('error', (err) => {
        console.error('Server error ', err);
    });
    app.use(express_1.default.urlencoded({
        extended: true,
    }));
    app.use(express_1.default.json({
        limit: '60mb',
    }));
    app.use(express_1.default.raw({
        type: '*/*',
    }));
    app.use(express_1.default.raw({
        type: 'multipart/form-data',
    }));
    app.get('/', function (req, res) {
        res.render('error', { titulo: 'hydra' });
    });
    return app;
}
exports.appExpress = appExpress;
//# sourceMappingURL=app.js.map