"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
const sqlite = require('./sqlite');
class configUsers {
    constructor(sql) {
        this.sql = sql;
        this.dbAdmin = new sql('admin');
        this.dbUser = new sql('users');
    }
    // User
    CheckUserHeaders(req) {
        const $_HEADERS = req.headers;
        if (!!$_HEADERS.user &&
            $_HEADERS.user.length &&
            !!$_HEADERS.user_pass &&
            $_HEADERS.user_pass.length) {
            return { erro: false };
        }
        return { erro: true, text: 'Not informed the user headers' };
    }
    CheckUserLogin(req) {
        return __awaiter(this, void 0, void 0, function* () {
            const checkHeaders = this.CheckUserHeaders(req);
            if (checkHeaders.erro === false) {
                const $_HEADERS = req.headers;
                const checkUser = yield this.dbUser.checkUser($_HEADERS.user, $_HEADERS.user_pass);
                const checkStatus = yield this.dbUser.checkActivateUserForPass($_HEADERS.user, $_HEADERS.user_pass);
                if (checkUser) {
                    if (checkStatus === false) {
                        return { erro: true, text: 'User status disabled' };
                    }
                    return { erro: false };
                }
                return { erro: true, text: 'User not found' };
            }
            return checkHeaders;
        });
    }
    // Admin
    CheckAdminHeaders(req) {
        const $_HEADERS = req.headers;
        if (!!$_HEADERS.admin &&
            $_HEADERS.admin.length &&
            !!$_HEADERS.admin_pass &&
            $_HEADERS.admin_pass.length) {
            return { erro: false };
        }
        return { erro: true, text: 'Not informed the admin headers' };
    }
    CheckAdminLogin(req) {
        return __awaiter(this, void 0, void 0, function* () {
            const checkHeaders = this.CheckAdminHeaders(req);
            if (checkHeaders.erro === false) {
                const $_HEADERS = req.headers;
                const checkAdmin = yield this.dbAdmin.checkUser($_HEADERS.admin, $_HEADERS.admin_pass);
                const checkStatus = yield this.dbAdmin.checkActivateUserForPass($_HEADERS.admin, $_HEADERS.admin_pass);
                if (checkAdmin) {
                    if (checkStatus === false) {
                        return { erro: true, text: 'Admin status disabled' };
                    }
                    return { erro: false };
                }
                return { erro: true, text: 'Admin not found' };
            }
            return checkHeaders;
        });
    }
}
module.exports = new configUsers(sqlite);
//# sourceMappingURL=treatment.js.map