"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
const treatment_1 = __importDefault(require("../../../help/treatment"));
class InicializePutUser {
    activateUserRouter(req, res) {
        return __awaiter(this, void 0, void 0, function* () {
            const body = req.body;
            const checkADM = yield treatment_1.default.CheckAdminLogin(req);
            if (checkADM.erro === false) {
                if (!!body.id && body.id.length) {
                    const change = yield treatment_1.default.dbUser.activateUser(body.id);
                    if (typeof change === 'boolean' && change === true) {
                        res.send({
                            erro: false,
                            text: 'User successfully activated!',
                        });
                    }
                    else {
                        res.send({
                            erro: true,
                            text: change,
                        });
                    }
                }
                else {
                    res.send({
                        erro: true,
                        text: 'Object incorrect',
                    });
                }
            }
            else {
                res.send(checkADM);
            }
        });
    }
    deactivateUserRouter(req, res) {
        return __awaiter(this, void 0, void 0, function* () {
            const body = req.body;
            const checkADM = yield treatment_1.default.CheckAdminLogin(req);
            if (checkADM.erro === false) {
                if (!!body.id && body.id.length) {
                    const change = yield treatment_1.default.dbUser.deactivateUser(body.id);
                    if (typeof change === 'boolean' && change === true) {
                        res.send({
                            erro: false,
                            text: 'User deactivated successfully!',
                        });
                    }
                    else {
                        res.send({
                            erro: true,
                            text: change,
                        });
                    }
                }
                else {
                    res.send({
                        erro: true,
                        text: 'Object incorrect',
                    });
                }
            }
            else {
                res.send(checkADM);
            }
        });
    }
    changeNameRouter(req, res) {
        return __awaiter(this, void 0, void 0, function* () {
            const body = req.body;
            const checkADM = yield treatment_1.default.CheckAdminLogin(req);
            if (checkADM.erro === false) {
                if (!!body.id && body.id.length && !!body.name && body.name.length) {
                    const change = yield treatment_1.default.dbUser.changeTheName(body.id, body.name);
                    if (typeof change === 'boolean' && change === true) {
                        res.send({
                            erro: false,
                            text: 'change name successfully',
                        });
                    }
                    else {
                        res.send({
                            erro: true,
                            text: change,
                        });
                    }
                }
                else {
                    res.send({
                        erro: true,
                        text: 'Object incorrect',
                    });
                }
            }
            else {
                res.send(checkADM);
            }
        });
    }
    changePasswordRouter(req, res) {
        return __awaiter(this, void 0, void 0, function* () {
            const body = req.body;
            const checkADM = yield treatment_1.default.CheckAdminLogin(req);
            if (checkADM.erro === false) {
                if (!!body.id &&
                    body.id.length &&
                    !!body.password &&
                    body.password.length) {
                    const change = yield treatment_1.default.dbUser.changeThePass(body.id, body.password);
                    if (typeof change === 'boolean' && change === true) {
                        res.send({
                            erro: false,
                            text: 'change password successfully',
                        });
                    }
                    else {
                        res.send({
                            erro: true,
                            text: change,
                        });
                    }
                }
                else {
                    res.send({
                        erro: true,
                        text: 'Object incorrect',
                    });
                }
            }
            else {
                res.send(checkADM);
            }
        });
    }
}
module.exports = new InicializePutUser();
//# sourceMappingURL=put.js.map