"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.init = void 0;
const child_process_1 = require("child_process");
const sessions_1 = require("../../help/sessions");
const treatment_1 = __importDefault(require("../../help/treatment"));
exports.init = new (class InicializePost {
    constructor() {
        this.child = '';
        this.res = '';
        this.option = '';
    }
    StartSession(req, res, option) {
        var _a;
        return __awaiter(this, void 0, void 0, function* () {
            const body = req.body;
            const reHttp = /^https?:/;
            const $_HEADERS_USER = (_a = req === null || req === void 0 ? void 0 : req.headers) === null || _a === void 0 ? void 0 : _a.user;
            this.res = res;
            this.option = option;
            if (option.authentication) {
                const user = yield treatment_1.default.CheckUserLogin(req);
                if (user.erro) {
                    return res.send(user);
                }
            }
            if (body.url && body.url.length && !reHttp.test(body.url)) {
                res.sender({ erro: true, text: 'Error http webHook' });
                return;
            }
            const session = yield sessions_1.sessionClient.newSession($_HEADERS_USER);
            if (session) {
                option.session = $_HEADERS_USER;
                option.url = body.url;
                const spawnArgs = [
                    __dirname + '../../../services/hydra.js',
                    JSON.stringify(option),
                ];
                this.child = (0, child_process_1.spawn)('node', spawnArgs, {
                    stdio: ['inherit', 'inherit', 'inherit', 'ipc'],
                });
                this.child.on('message', (response) => __awaiter(this, void 0, void 0, function* () {
                    if (response.connect) {
                        yield sessions_1.sessionClient.addInfoSession(response.session, {
                            connect: response.connect,
                        });
                    }
                    if (response.delsession) {
                        yield sessions_1.sessionClient.deleteSession(response.session);
                    }
                }));
                this.child.on('disconnect', (err) => {
                    console.log('disconnect', err ? err : '');
                });
                this.child.on('error', (err) => __awaiter(this, void 0, void 0, function* () {
                    if (err) {
                        console.log('on error', err);
                    }
                }));
                this.child.on('close', (code) => __awaiter(this, void 0, void 0, function* () {
                    console.log(`child process exited with code`, code);
                }));
                this.child.on('uncaughtException', (err) => {
                    console.log(err);
                });
                sessions_1.sessionClient.addInfoSession($_HEADERS_USER, { child: this.child });
                res.send({ erro: false, text: 'Wait for connection' });
            }
            else {
                const getId = yield sessions_1.sessionClient.getSessionId($_HEADERS_USER);
                const check = yield sessions_1.sessionClient.checkClient($_HEADERS_USER);
                if (typeof getId === 'number') {
                    const client = yield sessions_1.sessionClient.checkObjectSession($_HEADERS_USER, 'connect', getId);
                    if (check && client) {
                        res.send({ erro: false, text: 'Successfully connected!' });
                    }
                    else {
                        res.send({ erro: false, text: 'Wait for connection' });
                    }
                }
            }
        });
    }
    sendtext(req, res) {
        var _a;
        return __awaiter(this, void 0, void 0, function* () {
            const body = req.body;
            const $_HEADERS_USER = (_a = req === null || req === void 0 ? void 0 : req.headers) === null || _a === void 0 ? void 0 : _a.user;
            this.res = res;
            if (this.option.authentication) {
                const user = yield treatment_1.default.CheckUserLogin(req);
                if (user.erro) {
                    return res.send(user);
                }
            }
            if (!!body.to && body.to.length && !!body.body && body.body.length) {
                const check = yield sessions_1.sessionClient.checkClient($_HEADERS_USER);
                if (check) {
                    const getId = yield sessions_1.sessionClient.getSessionId($_HEADERS_USER);
                    if (typeof getId === 'number') {
                        const client = yield sessions_1.sessionClient.checkObjectSession($_HEADERS_USER, 'connect', getId);
                        if (client) {
                            const getUser = yield sessions_1.sessionClient.getUser($_HEADERS_USER);
                            getUser.child.send(Object.assign({ type: 'text' }, body));
                            this.child.on('message', (response) => {
                                if (response.result) {
                                    return res.send(response);
                                }
                            });
                        }
                    }
                }
                else {
                    res.send({
                        erro: true,
                        text: 'Not connected',
                    });
                }
            }
            else {
                res.send({
                    erro: true,
                    text: 'The parameters are missing',
                });
            }
        });
    }
})();
//# sourceMappingURL=post.js.map